# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetInstancesResult',
    'AwaitableGetInstancesResult',
    'get_instances',
]

@pulumi.output_type
class GetInstancesResult:
    """
    A collection of values returned by getInstances.
    """
    def __init__(__self__, filters=None, id=None, instances=None, region=None, sorts=None):
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instances and not isinstance(instances, list):
            raise TypeError("Expected argument 'instances' to be a list")
        pulumi.set(__self__, "instances", instances)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if sorts and not isinstance(sorts, list):
            raise TypeError("Expected argument 'sorts' to be a list")
        pulumi.set(__self__, "sorts", sorts)

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetInstancesFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def instances(self) -> Sequence['outputs.GetInstancesInstanceResult']:
        return pulumi.get(self, "instances")

    @property
    @pulumi.getter
    def region(self) -> Optional[str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def sorts(self) -> Optional[Sequence['outputs.GetInstancesSortResult']]:
        return pulumi.get(self, "sorts")


class AwaitableGetInstancesResult(GetInstancesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInstancesResult(
            filters=self.filters,
            id=self.id,
            instances=self.instances,
            region=self.region,
            sorts=self.sorts)


def get_instances(filters: Optional[Sequence[pulumi.InputType['GetInstancesFilterArgs']]] = None,
                  region: Optional[str] = None,
                  sorts: Optional[Sequence[pulumi.InputType['GetInstancesSortArgs']]] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInstancesResult:
    """
    Get information on instances for use in other resources, with the ability to filter and sort the results. If no filters are specified, all instances will be returned.

    Note: You can use the `Instance` data source to obtain metadata about a single instance if you already know the id, unique hostname, or unique tag to retrieve.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_civo as civo

    small_size = civo.get_instances(region="NYC1",
        filters=[civo.GetInstancesFilterArgs(
            key="size",
            values=[g3["small"]],
        )])
    ```

    <!-- schema generated by tfplugindocs -->
    ## Schema

    ### Optional

    - **filter** (Block Set) One or more key/value pairs on which to filter results (see below for nested schema)
    - **id** (String) The ID of this resource.
    - **region** (String) If used, all instances will be from the provided region
    - **sort** (Block List) One or more key/direction pairs on which to sort results (see below for nested schema)

    ### Read-Only

    - **instances** (List of Object) (see below for nested schema)

    <a id="nestedblock--filter"></a>
    ### Nested Schema for `filter`

    Required:

    - **key** (String) Filter instances by this key. This may be one of `cpu_cores`, `created_at`, `disk_gb`, `firewall_id`, `hostname`, `id`, `initial_password`, `initial_user`, `network_id`, `notes`, `private_ip`, `pseudo_ip`, `public_ip`, `ram_mb`, `region`, `reverse_dns`, `script`, `size`, `sshkey_id`, `status`, `tags`, `template`.
    - **values** (List of String) Only retrieves `instances` which keys has value that matches one of the values provided here

    Optional:

    - **all** (Boolean) Set to `true` to require that a field match all of the `values` instead of just one or more of them. This is useful when matching against multi-valued fields such as lists or sets where you want to ensure that all of the `values` are present in the list or set.
    - **match_by** (String) One of `exact` (default), `re`, or `substring`. For string-typed fields, specify `re` to match by using the `values` as regular expressions, or specify `substring` to match by treating the `values` as substrings to find within the string field.

    <a id="nestedblock--sort"></a>
    ### Nested Schema for `sort`

    Required:

    - **key** (String) Sort instances by this key. This may be one of `cpu_cores`, `created_at`, `disk_gb`, `firewall_id`, `hostname`, `id`, `initial_password`, `initial_user`, `network_id`, `notes`, `private_ip`, `pseudo_ip`, `public_ip`, `ram_mb`, `region`, `reverse_dns`, `script`, `size`, `sshkey_id`, `status`, `template`.

    Optional:

    - **direction** (String) The sort direction. This may be either `asc` or `desc`.

    <a id="nestedatt--instances"></a>
    ### Nested Schema for `instances`

    Read-Only:

    - **cpu_cores** (Number)
    - **created_at** (String)
    - **disk_gb** (Number)
    - **firewall_id** (String)
    - **hostname** (String)
    - **id** (String)
    - **initial_password** (String)
    - **initial_user** (String)
    - **network_id** (String)
    - **notes** (String)
    - **private_ip** (String)
    - **pseudo_ip** (String)
    - **public_ip** (String)
    - **ram_mb** (Number)
    - **region** (String)
    - **reverse_dns** (String)
    - **script** (String)
    - **size** (String)
    - **sshkey_id** (String)
    - **status** (String)
    - **tags** (Set of String)
    - **template** (String)
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['region'] = region
    __args__['sorts'] = sorts
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('civo:index/getInstances:getInstances', __args__, opts=opts, typ=GetInstancesResult).value

    return AwaitableGetInstancesResult(
        filters=__ret__.filters,
        id=__ret__.id,
        instances=__ret__.instances,
        region=__ret__.region,
        sorts=__ret__.sorts)
