# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetRegionResult',
    'AwaitableGetRegionResult',
    'get_region',
]

@pulumi.output_type
class GetRegionResult:
    """
    A collection of values returned by getRegion.
    """
    def __init__(__self__, filters=None, id=None, regions=None, sorts=None):
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if regions and not isinstance(regions, list):
            raise TypeError("Expected argument 'regions' to be a list")
        pulumi.set(__self__, "regions", regions)
        if sorts and not isinstance(sorts, list):
            raise TypeError("Expected argument 'sorts' to be a list")
        pulumi.set(__self__, "sorts", sorts)

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetRegionFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def regions(self) -> Sequence['outputs.GetRegionRegionResult']:
        return pulumi.get(self, "regions")

    @property
    @pulumi.getter
    def sorts(self) -> Optional[Sequence['outputs.GetRegionSortResult']]:
        return pulumi.get(self, "sorts")


class AwaitableGetRegionResult(GetRegionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRegionResult(
            filters=self.filters,
            id=self.id,
            regions=self.regions,
            sorts=self.sorts)


def get_region(filters: Optional[Sequence[pulumi.InputType['GetRegionFilterArgs']]] = None,
               sorts: Optional[Sequence[pulumi.InputType['GetRegionSortArgs']]] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRegionResult:
    """
    Retrieves information about the region that Civo supports, with the ability to filter the results.

    ## Schema

    ### Optional

    - **filter** (Block Set) One or more key/value pairs on which to filter results (see below for nested schema)
    - **id** (String) The ID of this resource.
    - **sort** (Block List) One or more key/direction pairs on which to sort results (see below for nested schema)

    ### Read-Only

    - **regions** (List of Object) (see below for nested schema)

    <a id="nestedblock--filter"></a>
    ### Nested Schema for `filter`

    Required:

    - **key** (String) Filter regions by this key. This may be one of `code`, `country`, `default`, `name`.
    - **values** (List of String) Only retrieves `regions` which keys has value that matches one of the values provided here

    Optional:

    - **all** (Boolean) Set to `true` to require that a field match all of the `values` instead of just one or more of them. This is useful when matching against multi-valued fields such as lists or sets where you want to ensure that all of the `values` are present in the list or set.
    - **match_by** (String) One of `exact` (default), `re`, or `substring`. For string-typed fields, specify `re` to match by using the `values` as regular expressions, or specify `substring` to match by treating the `values` as substrings to find within the string field.

    <a id="nestedblock--sort"></a>
    ### Nested Schema for `sort`

    Required:

    - **key** (String) Sort regions by this key. This may be one of `code`, `country`, `default`, `name`.

    Optional:

    - **direction** (String) The sort direction. This may be either `asc` or `desc`.

    <a id="nestedatt--regions"></a>
    ### Nested Schema for `regions`

    Read-Only:

    - **code** (String)
    - **country** (String)
    - **default** (Boolean)
    - **name** (String)
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['sorts'] = sorts
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('civo:index/getRegion:getRegion', __args__, opts=opts, typ=GetRegionResult).value

    return AwaitableGetRegionResult(
        filters=__ret__.filters,
        id=__ret__.id,
        regions=__ret__.regions,
        sorts=__ret__.sorts)
